####################################
#### Civilizations 4 Realism Mod                             ###
#### by jaynus                                                        ###
####################################
#
# Main CvRealism Class Descriptor
#

from CvPythonExtensions import *
import sys
import Popup as PyPopup
from PyHelpers import PyPlayer
import pickle
import CvEventManager
from CvScreenEnums import *
from PyHelpers import *
import CvUtil
import CvRealismNaturalDisasters

# Global variables #
gc = CyGlobalContext()
localText = CyTranslator()

#                                    #
# (Unit - Resource) Type Allocations #
#                                    #
UnitBonusTable = {
	"UNIT_MUSKETMAN" : "BONUS_MUSKETS"
}
#


#                                     #
# (Unit - Resource) Usage Allocations #
#                                     #
UnitBonusUsageTable = {
	"UNIT_MUSKETMAN" : "0.5"
}
#


# Our Root class for game modifications
class CvRealism:
    	# Check against our arrays to see if a unit requires a resource
    	# returns the resource index it requires
	def getUnitRequiresBonus(self, unitType):
		for unit in UnitBonusTable.keys():
			if gc.getInfoTypeForString(unit) == unitType:
				return gc.getInfoTypeForString(UnitBonusTable[unit])
		return -1


	#
	# Check against our arrays to see how much of a resource this unit uses
	# returns the decimal usage of the resource the unit uses
	def getUnitBonusUsage(self, unitType):

		for unit in UnitBonusTable.keys():
			if gc.getInfoTypeForString(unit) == unitType:
				return float(UnitBonusUsageTable[unit])
		return -1

	#
	# We have to find all the units that require a specific resource, and then do the math against that resource to figure out whats left
	# returns the avialable amount of the resource in question
	def getAvialableBonusCount(self, bonusType):
		totalAvial = gc.getActivePlayer().countOwnedBonuses(bonusType)

		for unit in UnitBonusTable.keys():
        			if gc.getInfoTypeForString(UnitBonusTable[unit]) == bonusType:
        				singleUsage = float(self.getUnitBonusUsage(gc.getInfoTypeForString(unit))) * float(gc.getActivePlayer().getUnitClassCount(gc.getInfoTypeForString(unit)))
        				totalAvial = totalAvial - singleUsage
        	return totalAvial


